#include <SPI.h>
#include <Ethernet.h>
#include <HttpClient.h>
#include <Xively.h>
#include <Wire.h>


float waterFlow = 200;
int flow;
int remappedFlow;
const byte mask = 0x7f;        //Added by DaveB     
     
//ubload Timer
unsigned long timer = 0;                  
unsigned long uploadDelay = 15000;
     
// MAC address for your Ethernet shield
byte mac[] = { 
  0xDE, 0xAD, 0xBE, 0xEF, 0xFE, 0xEF };

// Your Xively key to let you upload data
char xivelyKey[] = "pFJ0WCfu5ZMqBDdYCGRZeLEigSbQTHfeyzzX9Ly9Nqdk7JGy";

// Analog pin which we're monitoring (0 and 1 are used by the Ethernet shield)
int ledPin = 8;
int AlarmPin = 9;
int resetPin = 10;

unsigned long alarmDelay = 5000000;
unsigned long alarmTimer;
unsigned long alarmMillis;

// Define the strings for our datastream IDs
char sensorId[] = "Waterflow";

XivelyDatastream datastreams[] = {
  XivelyDatastream(sensorId, strlen(sensorId), DATASTREAM_FLOAT),

};
// Finally, wrap the datastreams into a feed
XivelyFeed feed(920215133, datastreams, 1 /* number of datastreams */);

EthernetClient client;
XivelyClient xivelyclient(client);


// ----------------------------------------------------------------   S E T U P  ----------------------
void setup() {
  
  timer = millis();
  Serial.begin(9600);
  
  pinMode(ledPin, OUTPUT);
  pinMode(AlarmPin, OUTPUT);
  pinMode(resetPin, OUTPUT);
  digitalWrite(AlarmPin, HIGH);
  digitalWrite(resetPin, LOW);
  Serial.println("Starting single datastream upload to Xively...");
  Serial.println();

  while (Ethernet.begin(mac) != 1)
  {
    Serial.println("Error getting IP address via DHCP, trying again...");
    delay(15000);
  }
  
}






void loop() {
  if (Serial.available() > 0) {
    Serial.println("Read sensor value ");
    waterFlow = readFlowFunc();
    Serial.print("Waterflow of (l/hr): ");
    Serial.println(waterFlow);
    Serial.print("Timer is: ");
    //Serial.println((timer+uploadDelay)-millis());
     
  }
  if(((timer+uploadDelay)-millis())<=2000){
  
    datastreams[0].setFloat(waterFlow);
    Serial.println("Uploading it to Xively");
    int ret = xivelyclient.put(feed, xivelyKey);
    Serial.print("xivelyclient.put returned ");
    Serial.println(ret);
    if(ret == 200){
      digitalWrite(ledPin, HIGH);
      Serial.println("HIGH");
      alarmTimer = millis();

      
    }else{
      digitalWrite(ledPin, LOW);
      Serial.println("LOW");
    }
  
    Serial.println();
    timer = millis();
  }
  
  
  
  
  alarmMillis = millis();
  //Serial.println((alarmTimer + alarmDelay)-alarmMillis);
  if(waterFlow < 250){
        digitalWrite(AlarmPin, LOW);
        //Serial.println("Alarm on, to low flow");
      }else if(alarmMillis > alarmTimer + alarmDelay){
        digitalWrite(AlarmPin, LOW);
        //Serial.println("Alarm on by upload timer");
        alarmTimer = alarmMillis - alarmDelay;
        digitalWrite(resetPin, HIGH);
        
      }else{
        digitalWrite(AlarmPin, HIGH);
        //Serial.println("Alarm off");
      }
  delay(10);

}


int readFlowFunc(){
  
  
    // get incoming byte:
    Serial.print("Received byte, raw value: ");
    flow = Serial.read();
    Serial.println(flow);
    remappedFlow = map(flow,0,257,0,2000);
    
    return(remappedFlow);
    
  
}


